"use strict";

var e = require("../language/kinds.js");

var i = require("../type/directives.js");

var t = require("../type/definition.js");

var r = require("../utilities/typeFromAST.js");

var n = require("./values.js");

function collectFieldsImpl(i, t, r, n, l, a, o) {
  for (var c = 0, s = l.selections; c < s.length; c += 1) {
    var u = s[c];
    switch (u.kind) {
     case e.Kind.FIELD:
      if (!shouldIncludeNode(r, u)) {
        continue;
      }
      var d = (F = u).alias ? F.alias.value : F.name.value;
      var v = a.get(d);
      if (void 0 !== v) {
        v.push(u);
      } else {
        a.set(d, [ u ]);
      }
      break;

     case e.Kind.INLINE_FRAGMENT:
      if (!shouldIncludeNode(r, u) || !doesFragmentConditionMatch(i, u, n)) {
        continue;
      }
      collectFieldsImpl(i, t, r, n, u.selectionSet, a, o);
      break;

     case e.Kind.FRAGMENT_SPREAD:
      var f = u.name.value;
      if (o.has(f) || !shouldIncludeNode(r, u)) {
        continue;
      }
      o.add(f);
      var p = t[f];
      if (!p || !doesFragmentConditionMatch(i, p, n)) {
        continue;
      }
      collectFieldsImpl(i, t, r, n, p.selectionSet, a, o);
    }
  }
  var F;
}

function shouldIncludeNode(e, t) {
  var r = n.getDirectiveValues(i.GraphQLSkipDirective, t, e);
  if (!0 === (null == r ? void 0 : r.if)) {
    return !1;
  }
  var l = n.getDirectiveValues(i.GraphQLIncludeDirective, t, e);
  if (!1 === (null == l ? void 0 : l.if)) {
    return !1;
  }
  return !0;
}

function doesFragmentConditionMatch(e, i, n) {
  var l = i.typeCondition;
  if (!l) {
    return !0;
  }
  var a = r.typeFromAST(e, l);
  if (a === n) {
    return !0;
  }
  if (t.isAbstractType(a)) {
    return e.isSubType(a, n);
  }
  return !1;
}

exports.collectFields = function collectFields(e, i, t, r, n) {
  var l = new Map;
  collectFieldsImpl(e, i, t, r, n, l, new Set);
  return l;
};

exports.collectSubfields = function collectSubfields(e, i, t, r, n) {
  var l = new Map;
  var a = new Set;
  for (var o = 0, c = n; o < c.length; o += 1) {
    var s = c[o];
    if (s.selectionSet) {
      collectFieldsImpl(e, i, t, r, s.selectionSet, l, a);
    }
  }
  return l;
};
