import { Kind as e } from "../language/kinds.mjs";

import { GraphQLSkipDirective as t, GraphQLIncludeDirective as i } from "../type/directives.mjs";

import { isAbstractType as n } from "../type/definition.mjs";

import { typeFromAST as l } from "../utilities/typeFromAST.mjs";

import { getDirectiveValues as o } from "./values.mjs";

function collectFields(e, t, i, n, l) {
  var o = new Map;
  collectFieldsImpl(e, t, i, n, l, o, new Set);
  return o;
}

function collectSubfields(e, t, i, n, l) {
  var o = new Map;
  var r = new Set;
  for (var c = 0, a = l; c < a.length; c += 1) {
    var s = a[c];
    if (s.selectionSet) {
      collectFieldsImpl(e, t, i, n, s.selectionSet, o, r);
    }
  }
  return o;
}

function collectFieldsImpl(t, i, n, l, o, r, c) {
  for (var a = 0, s = o.selections; a < s.length; a += 1) {
    var u = s[a];
    switch (u.kind) {
     case e.FIELD:
      if (!shouldIncludeNode(n, u)) {
        continue;
      }
      var d = (p = u).alias ? p.alias.value : p.name.value;
      var f = r.get(d);
      if (void 0 !== f) {
        f.push(u);
      } else {
        r.set(d, [ u ]);
      }
      break;

     case e.INLINE_FRAGMENT:
      if (!shouldIncludeNode(n, u) || !doesFragmentConditionMatch(t, u, l)) {
        continue;
      }
      collectFieldsImpl(t, i, n, l, u.selectionSet, r, c);
      break;

     case e.FRAGMENT_SPREAD:
      var m = u.name.value;
      if (c.has(m) || !shouldIncludeNode(n, u)) {
        continue;
      }
      c.add(m);
      var v = i[m];
      if (!v || !doesFragmentConditionMatch(t, v, l)) {
        continue;
      }
      collectFieldsImpl(t, i, n, l, v.selectionSet, r, c);
    }
  }
  var p;
}

function shouldIncludeNode(e, n) {
  var l = o(t, n, e);
  if (!0 === (null == l ? void 0 : l.if)) {
    return !1;
  }
  var r = o(i, n, e);
  if (!1 === (null == r ? void 0 : r.if)) {
    return !1;
  }
  return !0;
}

function doesFragmentConditionMatch(e, t, i) {
  var o = t.typeCondition;
  if (!o) {
    return !0;
  }
  var r = l(e, o);
  if (r === i) {
    return !0;
  }
  if (n(r)) {
    return e.isSubType(r, i);
  }
  return !1;
}

export { collectFields, collectSubfields };
