"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/memoize3.js");

var t = require("../jsutils/invariant.js");

var n = require("../jsutils/isPromise.js");

var i = require("../jsutils/isObjectLike.js");

var a = require("../jsutils/promiseReduce.js");

var o = require("../jsutils/promiseForObject.js");

var u = require("../jsutils/Path.js");

var l = require("../jsutils/isIterableObject.js");

var s = require("../error/GraphQLError.js");

var c = require("../error/locatedError.js");

var p = require("../language/ast.js");

var f = require("../language/kinds.js");

var v = require("../type/validate.js");

var d = require("../type/introspection.js");

var m = require("../type/definition.js");

var h = require("./values.js");

var y = require("./collectFields.js");

var b = r.memoize3((function(e, r, t) {
  return y.collectSubfields(e.schema, e.fragments, e.variableValues, r, t);
}));

function execute(e) {
  var r = e.rootValue;
  assertValidExecutionArguments(e.schema);
  var t = buildExecutionContext(e);
  if (!("schema" in t)) {
    return {
      errors: t
    };
  }
  try {
    var i = function executeOperation(e, r, t) {
      var i = e.schema.getRootType(r.operation);
      if (null == i) {
        throw new s.GraphQLError("Schema is not configured to execute " + r.operation + " operation.", r);
      }
      var o = y.collectFields(e.schema, e.fragments, e.variableValues, i, r.selectionSet);
      var l = void 0;
      switch (r.operation) {
       case p.OperationTypeNode.QUERY:
        return executeFields(e, i, t, l, o);

       case p.OperationTypeNode.MUTATION:
        return function executeFieldsSerially(e, r, t, i, o) {
          return a.promiseReduce(o.entries(), (function(a, o) {
            var l = o[0];
            var s = o[1];
            var c = u.addPath(i, l, r.name);
            var p = executeField(e, r, t, s, c);
            if (void 0 === p) {
              return a;
            }
            if (n.isPromise(p)) {
              return p.then((function(e) {
                a[l] = e;
                return a;
              }));
            }
            a[l] = p;
            return a;
          }), Object.create(null));
        }(e, i, t, l, o);

       case p.OperationTypeNode.SUBSCRIPTION:
        return executeFields(e, i, t, l, o);
      }
    }(t, t.operation, r);
    if (n.isPromise(i)) {
      return i.then((function(e) {
        return buildResponse(e, t.errors);
      }), (function(e) {
        t.errors.push(e);
        return buildResponse(null, t.errors);
      }));
    }
    return buildResponse(i, t.errors);
  } catch (e) {
    t.errors.push(e);
    return buildResponse(null, t.errors);
  }
}

function buildResponse(e, r) {
  return 0 === r.length ? {
    data: e
  } : {
    errors: r,
    data: e
  };
}

function assertValidExecutionArguments(e, r, t) {
  v.assertValidSchema(e);
}

function buildExecutionContext(e) {
  var r, t;
  var n = e.schema;
  var i = e.document;
  var a = e.rootValue;
  var o = e.contextValue;
  var u = e.variableValues;
  var l = e.operationName;
  var c = e.fieldResolver;
  var p = e.typeResolver;
  var v = e.subscribeFieldResolver;
  var d;
  var m = Object.create(null);
  for (var y = 0, b = i.definitions; y < b.length; y += 1) {
    var T = b[y];
    switch (T.kind) {
     case f.Kind.OPERATION_DEFINITION:
      if (null == l) {
        if (void 0 !== d) {
          return [ new s.GraphQLError("Must provide operation name if query contains multiple operations.") ];
        }
        d = T;
      } else if ((null === (r = T.name) || void 0 === r ? void 0 : r.value) === l) {
        d = T;
      }
      break;

     case f.Kind.FRAGMENT_DEFINITION:
      m[T.name.value] = T;
    }
  }
  if (!d) {
    if (null != l) {
      return [ new s.GraphQLError('Unknown operation named "' + l + '".') ];
    }
    return [ new s.GraphQLError("Must provide an operation.") ];
  }
  var j = null !== (t = d.variableDefinitions) && void 0 !== t ? t : [];
  var x = h.getVariableValues(n, j, null != u ? u : {}, {
    maxErrors: 50
  });
  if (x.errors) {
    return x.errors;
  }
  return {
    schema: n,
    fragments: m,
    rootValue: a,
    contextValue: o,
    operation: d,
    variableValues: x.coerced,
    fieldResolver: null != c ? c : defaultFieldResolver,
    typeResolver: null != p ? p : defaultTypeResolver,
    subscribeFieldResolver: null != v ? v : defaultFieldResolver,
    errors: []
  };
}

function executeFields(e, r, t, i, a) {
  var l = Object.create(null);
  var s = !1;
  for (var c = 0, p = a.entries(); c < p.length; c += 1) {
    var f = p[c];
    var v = f[0];
    var d = executeField(e, r, t, f[1], u.addPath(i, v, r.name));
    if (void 0 !== d) {
      l[v] = d;
      if (n.isPromise(d)) {
        s = !0;
      }
    }
  }
  if (!s) {
    return l;
  }
  return o.promiseForObject(l);
}

function executeField(e, r, t, i, a) {
  var o;
  var l = getFieldDef(e.schema, r, i[0]);
  if (!l) {
    return;
  }
  var s = l.type;
  var p = null !== (o = l.resolve) && void 0 !== o ? o : e.fieldResolver;
  var f = buildResolveInfo(e, l, i, r, a);
  try {
    var v = p(t, h.getArgumentValues(l, i[0], e.variableValues), e.contextValue, f);
    var d;
    if (n.isPromise(v)) {
      d = v.then((function(r) {
        return completeValue(e, s, i, f, a, r);
      }));
    } else {
      d = completeValue(e, s, i, f, a, v);
    }
    if (n.isPromise(d)) {
      return d.then(void 0, (function(r) {
        return handleFieldError(c.locatedError(r, i, u.pathToArray(a)), s, e);
      }));
    }
    return d;
  } catch (r) {
    return handleFieldError(c.locatedError(r, i, u.pathToArray(a)), s, e);
  }
}

function buildResolveInfo(e, r, t, n, i) {
  return {
    fieldName: r.name,
    fieldNodes: t,
    returnType: r.type,
    parentType: n,
    path: i,
    schema: e.schema,
    fragments: e.fragments,
    rootValue: e.rootValue,
    operation: e.operation,
    variableValues: e.variableValues
  };
}

function handleFieldError(e, r, t) {
  if (m.isNonNullType(r)) {
    throw e;
  }
  t.errors.push(e);
  return null;
}

function completeValue(r, i, a, o, p, f) {
  if (f instanceof Error) {
    throw f;
  }
  if (m.isNonNullType(i)) {
    var v = completeValue(r, i.ofType, a, o, p, f);
    if (null === v) {
      throw new Error("Cannot return null for non-nullable field " + o.parentType.name + "." + o.fieldName + ".");
    }
    return v;
  }
  if (null == f) {
    return null;
  }
  if (m.isListType(i)) {
    return function completeListValue(e, r, t, i, a, o) {
      if (!l.isIterableObject(o)) {
        throw new s.GraphQLError('Expected Iterable, but did not find one for field "' + i.parentType.name + "." + i.fieldName + '".');
      }
      var p = r.ofType;
      var f = !1;
      var v = Array.from(o, (function(r, o) {
        var l = u.addPath(a, o, void 0);
        try {
          var s;
          if (n.isPromise(r)) {
            s = r.then((function(r) {
              return completeValue(e, p, t, i, l, r);
            }));
          } else {
            s = completeValue(e, p, t, i, l, r);
          }
          if (n.isPromise(s)) {
            f = !0;
            return s.then(void 0, (function(r) {
              return handleFieldError(c.locatedError(r, t, u.pathToArray(l)), p, e);
            }));
          }
          return s;
        } catch (r) {
          return handleFieldError(c.locatedError(r, t, u.pathToArray(l)), p, e);
        }
      }));
      return f ? Promise.all(v) : v;
    }(r, i, a, o, p, f);
  }
  if (m.isLeafType(i)) {
    return function completeLeafValue(r, t) {
      var n = r.serialize(t);
      if (null == n) {
        throw new Error("Expected `" + e.inspect(r) + ".serialize(" + e.inspect(t) + ")` to return non-nullable value, returned: " + e.inspect(n));
      }
      return n;
    }(i, f);
  }
  if (m.isAbstractType(i)) {
    return function completeAbstractValue(e, r, t, i, a, o) {
      var u;
      var l = (null !== (u = r.resolveType) && void 0 !== u ? u : e.typeResolver)(o, e.contextValue, i, r);
      if (n.isPromise(l)) {
        return l.then((function(n) {
          return completeObjectValue(e, ensureValidRuntimeType(n, e, r, t, i, o), t, i, a, o);
        }));
      }
      return completeObjectValue(e, ensureValidRuntimeType(l, e, r, t, i, o), t, i, a, o);
    }(r, i, a, o, p, f);
  }
  if (m.isObjectType(i)) {
    return completeObjectValue(r, i, a, o, p, f);
  }
  t.invariant(!1);
}

function ensureValidRuntimeType(r, t, n, i, a, o) {
  if (null == r) {
    throw new s.GraphQLError('Abstract type "' + n.name + '" must resolve to an Object type at runtime for field "' + a.parentType.name + "." + a.fieldName + '". Either the "' + n.name + '" type should provide a "resolveType" function or each possible type should provide an "isTypeOf" function.', i);
  }
  if (m.isObjectType(r)) {
    throw new s.GraphQLError("Support for returning GraphQLObjectType from resolveType was removed in graphql-js@16.0.0 please return type name instead.");
  }
  if ("string" != typeof r) {
    throw new s.GraphQLError('Abstract type "' + n.name + '" must resolve to an Object type at runtime for field "' + a.parentType.name + "." + a.fieldName + '" with value ' + e.inspect(o) + ', received "' + e.inspect(r) + '".');
  }
  var u = t.schema.getType(r);
  if (null == u) {
    throw new s.GraphQLError('Abstract type "' + n.name + '" was resolved to a type "' + r + '" that does not exist inside the schema.', i);
  }
  if (!m.isObjectType(u)) {
    throw new s.GraphQLError('Abstract type "' + n.name + '" was resolved to a non-object type "' + r + '".', i);
  }
  if (!t.schema.isSubType(n, u)) {
    throw new s.GraphQLError('Runtime Object type "' + u.name + '" is not a possible type for "' + n.name + '".', i);
  }
  return u;
}

function completeObjectValue(e, r, t, i, a, o) {
  var u = b(e, r, t);
  if (r.isTypeOf) {
    var l = r.isTypeOf(o, e.contextValue, i);
    if (n.isPromise(l)) {
      return l.then((function(n) {
        if (!n) {
          throw invalidReturnTypeError(r, o, t);
        }
        return executeFields(e, r, o, a, u);
      }));
    }
    if (!l) {
      throw invalidReturnTypeError(r, o, t);
    }
  }
  return executeFields(e, r, o, a, u);
}

function invalidReturnTypeError(r, t, n) {
  return new s.GraphQLError('Expected value of type "' + r.name + '" but got: ' + e.inspect(t) + ".", n);
}

var defaultTypeResolver = function(e, r, t, a) {
  if (i.isObjectLike(e) && "string" == typeof e.__typename) {
    return e.__typename;
  }
  var o = t.schema.getPossibleTypes(a);
  var u = [];
  for (var l = 0; l < o.length; l++) {
    var s = o[l];
    if (s.isTypeOf) {
      var c = s.isTypeOf(e, r, t);
      if (n.isPromise(c)) {
        u[l] = c;
      } else if (c) {
        return s.name;
      }
    }
  }
  if (u.length) {
    return Promise.all(u).then((function(e) {
      for (var r = 0; r < e.length; r++) {
        if (e[r]) {
          return o[r].name;
        }
      }
    }));
  }
};

var defaultFieldResolver = function(e, r, t, n) {
  if (i.isObjectLike(e) || "function" == typeof e) {
    var a = e[n.fieldName];
    if ("function" == typeof a) {
      return e[n.fieldName](r, t, n);
    }
    return a;
  }
};

function getFieldDef(e, r, t) {
  var n = t.name.value;
  if (n === d.SchemaMetaFieldDef.name && e.getQueryType() === r) {
    return d.SchemaMetaFieldDef;
  } else if (n === d.TypeMetaFieldDef.name && e.getQueryType() === r) {
    return d.TypeMetaFieldDef;
  } else if (n === d.TypeNameMetaFieldDef.name) {
    return d.TypeNameMetaFieldDef;
  }
  return r.getFields()[n];
}

exports.assertValidExecutionArguments = assertValidExecutionArguments;

exports.buildExecutionContext = buildExecutionContext;

exports.buildResolveInfo = buildResolveInfo;

exports.defaultFieldResolver = defaultFieldResolver;

exports.defaultTypeResolver = defaultTypeResolver;

exports.execute = execute;

exports.executeSync = function executeSync(e) {
  var r = execute(e);
  if (n.isPromise(r)) {
    throw new Error("GraphQL execution failed to complete synchronously.");
  }
  return r;
};

exports.getFieldDef = getFieldDef;
