"use strict";

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/isAsyncIterable.js");

var a = require("../jsutils/Path.js");

var t = require("../error/GraphQLError.js");

var o = require("../error/locatedError.js");

var i = require("./collectFields.js");

var s = require("./values.js");

var n = require("./execute.js");

var u = require("./mapAsyncIterator.js");

async function createSourceEventStream(u, c, v, l, b, d, m) {
  n.assertValidExecutionArguments(u);
  var f = n.buildExecutionContext({
    schema: u,
    document: c,
    rootValue: v,
    contextValue: l,
    variableValues: b,
    operationName: d,
    subscribeFieldResolver: m
  });
  if (!("schema" in f)) {
    return {
      errors: f
    };
  }
  try {
    var h = await async function executeSubscription(e) {
      var r = e.schema;
      var u = e.fragments;
      var c = e.operation;
      var v = e.variableValues;
      var l = e.rootValue;
      var b = r.getSubscriptionType();
      if (null == b) {
        throw new t.GraphQLError("Schema is not configured to execute subscription operation.", c);
      }
      var d = i.collectFields(r, u, v, b, c.selectionSet);
      var m = [].concat(d.entries())[0];
      var f = m[0];
      var h = m[1];
      var p = n.getFieldDef(r, b, h[0]);
      if (!p) {
        throw new t.GraphQLError('The subscription field "' + h[0].name.value + '" is not defined.', h);
      }
      var E = a.addPath(void 0, f, b.name);
      var V = n.buildResolveInfo(e, p, h, b, E);
      try {
        var x;
        var y = s.getArgumentValues(p, h[0], v);
        var S = e.contextValue;
        var j = null !== (x = p.subscribe) && void 0 !== x ? x : e.subscribeFieldResolver;
        var w = await j(l, y, S, V);
        if (w instanceof Error) {
          throw w;
        }
        return w;
      } catch (e) {
        throw o.locatedError(e, h, a.pathToArray(E));
      }
    }(f);
    if (!r.isAsyncIterable(h)) {
      throw new Error("Subscription field must return Async Iterable. Received: " + e.inspect(h) + ".");
    }
    return h;
  } catch (e) {
    if (e instanceof t.GraphQLError) {
      return {
        errors: [ e ]
      };
    }
    throw e;
  }
}

exports.createSourceEventStream = createSourceEventStream;

exports.subscribe = async function subscribe(e) {
  var a = e.schema;
  var t = e.document;
  var o = e.rootValue;
  var i = e.contextValue;
  var s = e.variableValues;
  var c = e.operationName;
  var v = e.fieldResolver;
  var l = e.subscribeFieldResolver;
  var b = await createSourceEventStream(a, t, o, i, s, c, l);
  if (!r.isAsyncIterable(b)) {
    return b;
  }
  return u.mapAsyncIterator(b, (function(e) {
    return n.execute({
      schema: a,
      document: t,
      rootValue: e,
      contextValue: i,
      variableValues: s,
      operationName: c,
      fieldResolver: v
    });
  }));
};
