import { inspect as r } from "../jsutils/inspect.mjs";

import { isAsyncIterable as e } from "../jsutils/isAsyncIterable.mjs";

import { pathToArray as a, addPath as t } from "../jsutils/Path.mjs";

import { GraphQLError as o } from "../error/GraphQLError.mjs";

import { locatedError as i } from "../error/locatedError.mjs";

import { collectFields as s } from "./collectFields.mjs";

import { getArgumentValues as n } from "./values.mjs";

import { assertValidExecutionArguments as c, buildExecutionContext as u, getFieldDef as m, buildResolveInfo as v, execute as l } from "./execute.mjs";

import { mapAsyncIterator as f } from "./mapAsyncIterator.mjs";

async function subscribe(r) {
  var a = r.schema;
  var t = r.document;
  var o = r.rootValue;
  var i = r.contextValue;
  var s = r.variableValues;
  var n = r.operationName;
  var c = r.fieldResolver;
  var u = r.subscribeFieldResolver;
  var m = await createSourceEventStream(a, t, o, i, s, n, u);
  if (!e(m)) {
    return m;
  }
  return f(m, (function(r) {
    return l({
      schema: a,
      document: t,
      rootValue: r,
      contextValue: i,
      variableValues: s,
      operationName: n,
      fieldResolver: c
    });
  }));
}

async function createSourceEventStream(l, f, p, b, d, h, j) {
  c(l);
  var w = u({
    schema: l,
    document: f,
    rootValue: p,
    contextValue: b,
    variableValues: d,
    operationName: h,
    subscribeFieldResolver: j
  });
  if (!("schema" in w)) {
    return {
      errors: w
    };
  }
  try {
    var V = await async function executeSubscription(r) {
      var e = r.schema;
      var c = r.fragments;
      var u = r.operation;
      var l = r.variableValues;
      var f = r.rootValue;
      var p = e.getSubscriptionType();
      if (null == p) {
        throw new o("Schema is not configured to execute subscription operation.", u);
      }
      var b = s(e, c, l, p, u.selectionSet);
      var d = [].concat(b.entries())[0];
      var h = d[0];
      var j = d[1];
      var w = m(e, p, j[0]);
      if (!w) {
        throw new o('The subscription field "' + j[0].name.value + '" is not defined.', j);
      }
      var V = t(void 0, h, p.name);
      var S = v(r, w, j, p, V);
      try {
        var y;
        var x = n(w, j[0], l);
        var E = r.contextValue;
        var R = null !== (y = w.subscribe) && void 0 !== y ? y : r.subscribeFieldResolver;
        var F = await R(f, x, E, S);
        if (F instanceof Error) {
          throw F;
        }
        return F;
      } catch (r) {
        throw i(r, j, a(V));
      }
    }(w);
    if (!e(V)) {
      throw new Error("Subscription field must return Async Iterable. Received: " + r(V) + ".");
    }
    return V;
  } catch (r) {
    if (r instanceof o) {
      return {
        errors: [ r ]
      };
    }
    throw r;
  }
}

export { createSourceEventStream, subscribe };
