var e = function Location(e, i, t) {
  this.start = e.start;
  this.end = i.end;
  this.startToken = e;
  this.endToken = i;
  this.source = t;
};

e.prototype.toJSON = function toJSON() {
  return {
    start: this.start,
    end: this.end
  };
};

var i = function Token(e, i, t, n, s, a) {
  this.kind = e;
  this.start = i;
  this.end = t;
  this.line = n;
  this.column = s;
  this.value = a;
  this.prev = null;
  this.next = null;
};

i.prototype.toJSON = function toJSON() {
  return {
    kind: this.kind,
    value: this.value,
    line: this.line,
    column: this.column
  };
};

var t = new Set(Object.keys({
  Name: [],
  Document: [ "definitions" ],
  OperationDefinition: [ "name", "variableDefinitions", "directives", "selectionSet" ],
  VariableDefinition: [ "variable", "type", "defaultValue", "directives" ],
  Variable: [ "name" ],
  SelectionSet: [ "selections" ],
  Field: [ "alias", "name", "arguments", "directives", "selectionSet" ],
  Argument: [ "name", "value" ],
  FragmentSpread: [ "name", "directives" ],
  InlineFragment: [ "typeCondition", "directives", "selectionSet" ],
  FragmentDefinition: [ "name", "variableDefinitions", "typeCondition", "directives", "selectionSet" ],
  IntValue: [],
  FloatValue: [],
  StringValue: [],
  BooleanValue: [],
  NullValue: [],
  EnumValue: [],
  ListValue: [ "values" ],
  ObjectValue: [ "fields" ],
  ObjectField: [ "name", "value" ],
  Directive: [ "name", "arguments" ],
  NamedType: [ "name" ],
  ListType: [ "type" ],
  NonNullType: [ "type" ],
  SchemaDefinition: [ "description", "directives", "operationTypes" ],
  OperationTypeDefinition: [ "type" ],
  ScalarTypeDefinition: [ "description", "name", "directives" ],
  ObjectTypeDefinition: [ "description", "name", "interfaces", "directives", "fields" ],
  FieldDefinition: [ "description", "name", "arguments", "type", "directives" ],
  InputValueDefinition: [ "description", "name", "type", "defaultValue", "directives" ],
  InterfaceTypeDefinition: [ "description", "name", "interfaces", "directives", "fields" ],
  UnionTypeDefinition: [ "description", "name", "directives", "types" ],
  EnumTypeDefinition: [ "description", "name", "directives", "values" ],
  EnumValueDefinition: [ "description", "name", "directives" ],
  InputObjectTypeDefinition: [ "description", "name", "directives", "fields" ],
  DirectiveDefinition: [ "description", "name", "arguments", "locations" ],
  SchemaExtension: [ "directives", "operationTypes" ],
  ScalarTypeExtension: [ "name", "directives" ],
  ObjectTypeExtension: [ "name", "interfaces", "directives", "fields" ],
  InterfaceTypeExtension: [ "name", "interfaces", "directives", "fields" ],
  UnionTypeExtension: [ "name", "directives", "types" ],
  EnumTypeExtension: [ "name", "directives", "values" ],
  InputObjectTypeExtension: [ "name", "directives", "fields" ]
}));

function isNode(e) {
  var i = null == e ? void 0 : e.kind;
  return "string" == typeof i && t.has(i);
}

var n;

!function(e) {
  e.QUERY = "query";
  e.MUTATION = "mutation";
  e.SUBSCRIPTION = "subscription";
}(n || (n = {}));

export { e as Location, n as OperationTypeNode, i as Token, isNode };
