"use strict";

var r = require("../error/GraphQLError.js");

var e = require("../language/characterClasses.js");

function assertName(a) {
  if (0 === a.length) {
    throw new r.GraphQLError("Expected name to be a non-empty string.");
  }
  for (var t = 1; t < a.length; ++t) {
    if (!e.isNameContinue(a.charCodeAt(t))) {
      throw new r.GraphQLError('Names must only contain [_a-zA-Z0-9] but "' + a + '" does not.');
    }
  }
  if (!e.isNameStart(a.charCodeAt(0))) {
    throw new r.GraphQLError('Names must start with [_a-zA-Z] but "' + a + '" does not.');
  }
  return a;
}

exports.assertEnumValueName = function assertEnumValueName(e) {
  if ("true" === e || "false" === e || "null" === e) {
    throw new r.GraphQLError("Enum values cannot be named: " + e);
  }
  return assertName(e);
};

exports.assertName = assertName;
