import { GraphQLError as e } from "../error/GraphQLError.mjs";

import { isNameContinue as t, isNameStart as r } from "../language/characterClasses.mjs";

function assertName(a) {
  if (0 === a.length) {
    throw new e("Expected name to be a non-empty string.");
  }
  for (var n = 1; n < a.length; ++n) {
    if (!t(a.charCodeAt(n))) {
      throw new e('Names must only contain [_a-zA-Z0-9] but "' + a + '" does not.');
    }
  }
  if (!r(a.charCodeAt(0))) {
    throw new e('Names must start with [_a-zA-Z] but "' + a + '" does not.');
  }
  return a;
}

function assertEnumValueName(t) {
  if ("true" === t || "false" === t || "null" === t) {
    throw new e("Enum values cannot be named: " + t);
  }
  return assertName(t);
}

export { assertEnumValueName, assertName };
