import { GraphQLError as r } from "../error/GraphQLError.mjs";

import { assertName as t } from "../type/assertName.mjs";

function assertValidName(r) {
  var t = isValidNameError(r);
  if (t) {
    throw t;
  }
  return r;
}

function isValidNameError(e) {
  if (e.startsWith("__")) {
    return new r('Name "' + e + '" must not begin with "__", which is reserved by GraphQL introspection.');
  }
  try {
    t(e);
  } catch (r) {
    return r;
  }
}

export { assertValidName, isValidNameError };
