"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/keyValMap.js");

var n = require("../language/kinds.js");

exports.valueFromASTUntyped = function valueFromASTUntyped(r, a) {
  switch (r.kind) {
   case n.Kind.NULL:
    return null;

   case n.Kind.INT:
    return parseInt(r.value, 10);

   case n.Kind.FLOAT:
    return parseFloat(r.value);

   case n.Kind.STRING:
   case n.Kind.ENUM:
   case n.Kind.BOOLEAN:
    return r.value;

   case n.Kind.LIST:
    return r.values.map((function(e) {
      return valueFromASTUntyped(e, a);
    }));

   case n.Kind.OBJECT:
    return e.keyValMap(r.fields, (function(e) {
      return e.name.value;
    }), (function(e) {
      return valueFromASTUntyped(e.value, a);
    }));

   case n.Kind.VARIABLE:
    return null == a ? void 0 : a[r.name.value];
  }
};
