import { keyValMap as e } from "../jsutils/keyValMap.mjs";

import { Kind as r } from "../language/kinds.mjs";

function valueFromASTUntyped(a, n) {
  switch (a.kind) {
   case r.NULL:
    return null;

   case r.INT:
    return parseInt(a.value, 10);

   case r.FLOAT:
    return parseFloat(a.value);

   case r.STRING:
   case r.ENUM:
   case r.BOOLEAN:
    return a.value;

   case r.LIST:
    return a.values.map((function(e) {
      return valueFromASTUntyped(e, n);
    }));

   case r.OBJECT:
    return e(a.fields, (function(e) {
      return e.name.value;
    }), (function(e) {
      return valueFromASTUntyped(e.value, n);
    }));

   case r.VARIABLE:
    return null == n ? void 0 : n[a.name.value];
  }
}

export { valueFromASTUntyped };
