"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/invariant.js");

var i = require("../../error/GraphQLError.js");

var r = require("../../language/kinds.js");

var n = require("../../language/ast.js");

var t = require("../../language/directiveLocation.js");

var a = require("../../type/directives.js");

exports.KnownDirectivesRule = function KnownDirectivesRule(E) {
  var I = Object.create(null);
  var c = E.getSchema();
  for (var N = 0, o = c ? c.getDirectives() : a.specifiedDirectives; N < o.length; N += 1) {
    var T = o[N];
    I[T.name] = T.locations;
  }
  for (var D = 0, v = E.getDocument().definitions; D < v.length; D += 1) {
    var s = v[D];
    if (s.kind === r.Kind.DIRECTIVE_DEFINITION) {
      I[s.name.value] = s.locations.map((function(e) {
        return e.value;
      }));
    }
  }
  return {
    Directive: function Directive(a, c, N, o, T) {
      var D = a.name.value;
      var v = I[D];
      if (!v) {
        E.reportError(new i.GraphQLError('Unknown directive "@' + D + '".', a));
        return;
      }
      var s = function getDirectiveLocationForASTPath(i) {
        var a = i[i.length - 1];
        "kind" in a || e.invariant(!1);
        switch (a.kind) {
         case r.Kind.OPERATION_DEFINITION:
          return function getDirectiveLocationForOperation(e) {
            switch (e) {
             case n.OperationTypeNode.QUERY:
              return t.DirectiveLocation.QUERY;

             case n.OperationTypeNode.MUTATION:
              return t.DirectiveLocation.MUTATION;

             case n.OperationTypeNode.SUBSCRIPTION:
              return t.DirectiveLocation.SUBSCRIPTION;
            }
          }(a.operation);

         case r.Kind.FIELD:
          return t.DirectiveLocation.FIELD;

         case r.Kind.FRAGMENT_SPREAD:
          return t.DirectiveLocation.FRAGMENT_SPREAD;

         case r.Kind.INLINE_FRAGMENT:
          return t.DirectiveLocation.INLINE_FRAGMENT;

         case r.Kind.FRAGMENT_DEFINITION:
          return t.DirectiveLocation.FRAGMENT_DEFINITION;

         case r.Kind.VARIABLE_DEFINITION:
          return t.DirectiveLocation.VARIABLE_DEFINITION;

         case r.Kind.SCHEMA_DEFINITION:
         case r.Kind.SCHEMA_EXTENSION:
          return t.DirectiveLocation.SCHEMA;

         case r.Kind.SCALAR_TYPE_DEFINITION:
         case r.Kind.SCALAR_TYPE_EXTENSION:
          return t.DirectiveLocation.SCALAR;

         case r.Kind.OBJECT_TYPE_DEFINITION:
         case r.Kind.OBJECT_TYPE_EXTENSION:
          return t.DirectiveLocation.OBJECT;

         case r.Kind.FIELD_DEFINITION:
          return t.DirectiveLocation.FIELD_DEFINITION;

         case r.Kind.INTERFACE_TYPE_DEFINITION:
         case r.Kind.INTERFACE_TYPE_EXTENSION:
          return t.DirectiveLocation.INTERFACE;

         case r.Kind.UNION_TYPE_DEFINITION:
         case r.Kind.UNION_TYPE_EXTENSION:
          return t.DirectiveLocation.UNION;

         case r.Kind.ENUM_TYPE_DEFINITION:
         case r.Kind.ENUM_TYPE_EXTENSION:
          return t.DirectiveLocation.ENUM;

         case r.Kind.ENUM_VALUE_DEFINITION:
          return t.DirectiveLocation.ENUM_VALUE;

         case r.Kind.INPUT_OBJECT_TYPE_DEFINITION:
         case r.Kind.INPUT_OBJECT_TYPE_EXTENSION:
          return t.DirectiveLocation.INPUT_OBJECT;

         case r.Kind.INPUT_VALUE_DEFINITION:
          var E = i[i.length - 3];
          "kind" in E || e.invariant(!1);
          return E.kind === r.Kind.INPUT_OBJECT_TYPE_DEFINITION ? t.DirectiveLocation.INPUT_FIELD_DEFINITION : t.DirectiveLocation.ARGUMENT_DEFINITION;

         default:
          e.invariant(!1);
        }
      }(T);
      if (s && !v.includes(s)) {
        E.reportError(new i.GraphQLError('Directive "@' + D + '" may not be used on ' + s + ".", a));
      }
    }
  };
};
