import { GraphQLError as e } from "../../error/GraphQLError.mjs";

import { Kind as n } from "../../language/kinds.mjs";

import { collectFields as t } from "../../execution/collectFields.mjs";

function SingleFieldSubscriptionsRule(i) {
  return {
    OperationDefinition: function OperationDefinition(r) {
      if ("subscription" === r.operation) {
        var o = i.getSchema();
        var l = o.getSubscriptionType();
        if (l) {
          var s = r.name ? r.name.value : null;
          var a = Object.create(null);
          var u = i.getDocument();
          var c = Object.create(null);
          for (var p = 0, m = u.definitions; p < m.length; p += 1) {
            var v = m[p];
            if (v.kind === n.FRAGMENT_DEFINITION) {
              c[v.name.value] = v;
            }
          }
          var f = t(o, c, a, l, r.selectionSet);
          if (f.size > 1) {
            var S = [].concat(f.values()).slice(1).flat();
            i.reportError(new e(null != s ? 'Subscription "' + s + '" must select only one top level field.' : "Anonymous Subscription must select only one top level field.", S));
          }
          for (var b = 0, d = f.values(); b < d.length; b += 1) {
            var g = d[b];
            if (g[0].name.value.startsWith("__")) {
              i.reportError(new e(null != s ? 'Subscription "' + s + '" must not select an introspection top level field.' : "Anonymous Subscription must not select an introspection top level field.", g));
            }
          }
        }
      }
    }
  };
}

export { SingleFieldSubscriptionsRule };
