"use strict";

var e = require("../../jsutils/groupBy.js");

var n = require("../../error/GraphQLError.js");

exports.UniqueArgumentDefinitionNamesRule = function UniqueArgumentDefinitionNamesRule(r) {
  return {
    DirectiveDefinition: function DirectiveDefinition(e) {
      var n;
      var r = null !== (n = e.arguments) && void 0 !== n ? n : [];
      return checkArgUniqueness("@" + e.name.value, r);
    },
    InterfaceTypeDefinition: checkArgUniquenessPerField,
    InterfaceTypeExtension: checkArgUniquenessPerField,
    ObjectTypeDefinition: checkArgUniquenessPerField,
    ObjectTypeExtension: checkArgUniquenessPerField
  };
  function checkArgUniquenessPerField(e) {
    var n;
    var r = e.name.value;
    for (var i = 0, u = null !== (n = e.fields) && void 0 !== n ? n : []; i < u.length; i += 1) {
      var t = u[i];
      var a;
      checkArgUniqueness(r + "." + t.name.value, null !== (a = t.arguments) && void 0 !== a ? a : []);
    }
    return !1;
  }
  function checkArgUniqueness(i, u) {
    for (var t = 0, a = e.groupBy(u, (function(e) {
      return e.name.value;
    })); t < a.length; t += 1) {
      var c = a[t];
      var s = c[1];
      if (s.length > 1) {
        r.reportError(new n.GraphQLError('Argument "' + i + "(" + c[0] + ':)" can only be defined once.', s.map((function(e) {
          return e.name;
        }))));
      }
    }
    return !1;
  }
};
