import { groupBy as e } from "../../jsutils/groupBy.mjs";

import { GraphQLError as n } from "../../error/GraphQLError.mjs";

function UniqueArgumentDefinitionNamesRule(r) {
  return {
    DirectiveDefinition: function DirectiveDefinition(e) {
      var n;
      var r = null !== (n = e.arguments) && void 0 !== n ? n : [];
      return checkArgUniqueness("@" + e.name.value, r);
    },
    InterfaceTypeDefinition: checkArgUniquenessPerField,
    InterfaceTypeExtension: checkArgUniquenessPerField,
    ObjectTypeDefinition: checkArgUniquenessPerField,
    ObjectTypeExtension: checkArgUniquenessPerField
  };
  function checkArgUniquenessPerField(e) {
    var n;
    var r = e.name.value;
    for (var i = 0, t = null !== (n = e.fields) && void 0 !== n ? n : []; i < t.length; i += 1) {
      var u = t[i];
      var o;
      checkArgUniqueness(r + "." + u.name.value, null !== (o = u.arguments) && void 0 !== o ? o : []);
    }
    return !1;
  }
  function checkArgUniqueness(i, t) {
    for (var u = 0, o = e(t, (function(e) {
      return e.name.value;
    })); u < o.length; u += 1) {
      var c = o[u];
      var a = c[1];
      if (a.length > 1) {
        r.reportError(new n('Argument "' + i + "(" + c[0] + ':)" can only be defined once.', a.map((function(e) {
          return e.name;
        }))));
      }
    }
    return !1;
  }
}

export { UniqueArgumentDefinitionNamesRule };
